#include "GL_RendererStateVariables.h"
#include <GL/glu.h>

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

RendererStateVariables::RendererStateVariables()
: StateVariables()
{
}

RendererStateVariables::~RendererStateVariables()
{
}


void RendererStateVariables::initSelect(double , double )
{
//  _matrixStack.push_front(MFFloat());
 /* GLfloat matrix[16];
  glGetFloatv(GL_PROJECTION_MATRIX, matrix);
  
  const int SENSITIVITY = 3;
  // Loads the matrices
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  GLint viewport[4];
  glGetIntegerv(GL_VIEWPORT, viewport);
  gluPickMatrix(x, viewport[3] - y, SENSITIVITY, SENSITIVITY, viewport);
  glMultMatrixf(matrix);

  glGetFloatv(GL_PROJECTION_MATRIX, matrix);
  
  cout << matrix[0] << ", " << matrix[1] << ", " << matrix[2] << ", " << matrix[3] << ", " << endl;
  cout << matrix[4] << ", " << matrix[5] << ", " << matrix[6] << ", " << matrix[7] << ", " << endl;
  cout << matrix[8] << ", " << matrix[9] << ", " << matrix[10] << ", " << matrix[11] << ", " << endl;
  cout << matrix[12] << ", " << matrix[13] << ", " << matrix[14] << ", " << matrix[15] << ", " << endl << endl;
*/
  glSelectBuffer(32768, _hits);
  glRenderMode(GL_SELECT);
  glInitNames();
  glPushName(0);
}

void RendererStateVariables::finishSelect()
{
  glFlush();

  _shape = 0;

  // Get the results 
  GLint nb_hits = glRenderMode(GL_RENDER);

  // Too many elements in selection buffer
  if (nb_hits <= 0)
  { 
    cout << "found nothing" << endl;
    _shapeVector.clear();
    return;
  }
  else
    cout << nb_hits << " hits:" << endl;
  
  
  for (unsigned int i = 0; i < static_cast<unsigned int>(nb_hits*4 + 1); ++i)
    cout << _hits[i] << endl;
 
  //interpreting the results.
  unsigned zMin = _hits[2];
  int selectedId(_hits[3]);

  for (int i = 1; i < nb_hits; ++i)
  {
    // Prefer vertices over edges and edges over faces
    if (_hits[i*4 + 2] < zMin)
    {
      zMin = _hits[i*4 + 2];
      selectedId = _hits[i*4 + 3];
    }
  }  

  cout << "found " << selectedId << " in " << _shapeVector.size() << endl;
  //_shape = _shapeVector[selectedId];
  
/*  _matrixStack.clear();
  _matrixVector.clear();*/
  _shapeVector.clear();
}

void RendererStateVariables::storeShape(X3DShapeNode *S)
{
  _shapeVector.push_back(S);
}

void RendererStateVariables::setSelectionMode(bool value)
{
  _selectionMode = value;
}

}
}
