#include "X3D_CoordMerger.h"
#include "X3D_CoordMergerRenderingVisitor.h"
#include "DFSGraphTraversal.h"

namespace X3DTK {
namespace X3D {

CoordMerger::CoordMerger()
: X3DOnePassProcessor()
{
  stateVariables = GraphTraversal::getInstanceOf<CoordMergerStateVariables>();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new CoordMergerRenderingVisitor());
}

CoordMerger::~CoordMerger()
{
  GraphTraversal::removeInstanceOf<CoordMergerStateVariables>();

  delete graphTraversal;
}

void CoordMerger::merge(SFAbstractNode N)
{
  graphTraversal->traverse(N);
  stateVariables->finish();
}


}
}
